<?php
namespace Fiscal\Logic\CalculoReceitaBruta;
/**
 * Description of DeduzReceita
 *
 * @author carinaoliveira
 */
use Indeterminado\Entities\Tpopersimplesnac;

class DeduzReceita {
    
    public static function deleteTpOper($cdtipooper,$cdsimplesnac,$identrsaidop) {
        
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        
        $sucesso = false;
        
        try {
            
            $tpoper = \Indeterminado\Entities\Tpopersimplesnac::findOneByCdtipooperAndCdsimplesnacionalAndIdentrsaidop($cdtipooper,$cdsimplesnac,$identrsaidop);
            $tpoper->delete(); //deleta tipo de operação
            
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->flush();
            $db->commit();
                        
            $sucesso = true;
            
        } catch (\Exception $e) {
            $db->rollback();
        }
        
        return $sucesso;
        
    }
    
    public static function alteraParaDeletarTpOper($cdtipooper,$cdsimplesnac,$identrsaidop) {
        
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        
        $sucesso = false;

        try {
            
            $tpoper = \Indeterminado\Entities\Tpopersimplesnac::findOneByCdtipooperAndCdsimplesnacionalAndIdentrsaidop($cdtipooper,$cdsimplesnac,$identrsaidop);
            $tpoper->setIdtipooperrec('I');
            $tpoper->persist();

            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->flush();
            $db->commit();
            
            $sucesso = true;
        }            
        catch (\Exception $e) {
            throw $e;
            $db->rollback();
        }  
        
        return $sucesso;
    } 
    
    //Verifica se o tp de operação informado ja existe na tabela
    public static function existeTpOper($campos) {
        
        try {
            $tpoper = \Indeterminado\Entities\Tpopersimplesnac::findOneByCdtipooperAndCdsimplesnacionalAndIdentrsaidop($campos['CDTIPOOPER'],$campos['CDSIMPLESNACIONAL'],$campos['IDENTRSAIDOP']);
            
            
            //se existir na tabela, verifica se existe nessa tab
            if(is_object($tpoper)) {
                $idtpoperrec = $tpoper->getIdtipooperrec();
                //se nao existir nessa tab, chama a função altera para incluir
                if($idtpoperrec == 'I') {
                    $sucesso = self::alteraParaIncluirTpOper($campos);
                }
                //se existir, aborta a operaçao
                elseif($idtpoperrec == 'C' || $idtpoperrec == 'D') {
                    $message = tk_get_message_by_name('msg_TpOperJaCadastrado');
                    tk_message($message, 'warning');
                    $sucesso = 'E';
                }                              
                
            }
            //se não existir, chama a função insere
            elseif(!is_object($tpoper)) {
                $sucesso = self::insereTpOper($campos);
            }
        }            
        catch (\Exception $e) {
            throw $e;
            $db->rollback();
        }
        
        return $sucesso;
    }
    
    public static function insereTpOper($campos) {
        
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        
        $sucesso = false;
        
        try {
            $tpoper = new Tpopersimplesnac();
            
            $tpoper->setCdsimplesnacional($campos['CDSIMPLESNACIONAL']);
            $tpoper->setNrorg($campos['NRORG']);
            $tpoper->setCdtipooper($campos['CDTIPOOPER']);
            $tpoper->setIdentrsaidop($campos['IDENTRSAIDOP']);
            $tpoper->setIdtipoopertab($campos['IDTIPOOPERTAB']); 
            $tpoper->setIdtipooperrec($campos['IDTIPOOPERREC']);
            $tpoper->setIdativo($campos['IDATIVO']);            
            $tpoper->setCdoperinclusao($campos['CDOPERINCLUSAO']);
            $tpoper->setDtultatu($campos['DTULTATU']);
            $tpoper->setDtinclusao($campos['DTINCLUSAO']);            
            $tpoper->setNrorgultatu($campos['NRORGULTATU']);
            $tpoper->setCdoperultatu($campos['CDOPERULTATU']);
            $tpoper->setNrorginclusao($campos['NRORGINCLUSAO']);     
            
            $tpoper->persist();
            
            $connection->flush();
            $db->commit();

            $message = tk_get_message_by_name('msg_ger04100_inserido');
            tk_message($message, 'success');
                        
            $sucesso = true;
            
        } catch (\Exception $e) {
            $db->rollback();
        }
        
        return $sucesso;        
    }
    
    public static function alteraParaIncluirTpOper($campos) {
        
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        
        $sucesso = false;

        try {
            $tpoper = \Indeterminado\Entities\Tpopersimplesnac::findOneByCdtipooperAndCdsimplesnacionalAndIdentrsaidop($campos['CDTIPOOPER'],$campos['CDSIMPLESNACIONAL'],$campos['IDENTRSAIDOP']);
            $tpoper->setIdtipooperrec('D');
            $tpoper->persist();

            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->flush();
            $db->commit();
            
            $sucesso = true;
            
        }            
        catch (\Exception $e) {
            throw $e;
            $db->rollback();
        }  
        
        return $sucesso;
        
    }
    
}

?>
