CREATE OR REPLACE
PROCEDURE GRAVA_IMP_FEDERAIS_VND(
   P_CDFILIAL  IN FILIAL.CDFILIAL%TYPE,
   P_CDCLIENTE IN CLIENTE.CDCLIENTE%TYPE,
   P_TIPOOPER  IN TIPOOPERAC.CDTIPOOPER%TYPE,
   P_LANCTONF  IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CDCAIXA   IN VARCHAR,
   P_TCDCAIXA  IN VARCHAR,
   P_DTINICIAL IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_DTFINAL   IN NOTAFISCAL.DTEMISSAO%TYPE)
AS
   V_GRUPOFISC         VARCHAR(10);
   V_CDEMPRESA         VARCHAR(2);
   V_CDINSCESTA        VARCHAR(30);
   V_VRALIQIMP         NUMBER;
   V_CSTNFE            VARCHAR(5);
   V_IDMODBCNFE        VARCHAR(5);
   V_IDMODBCSTNFE      VARCHAR(5);
   V_CDTPCRPICOSTNFE   VARCHAR(10);
   V_CDNATUBCPCSTNFE   VARCHAR(10);
   V_IDMOTIDESSTNFE    VARCHAR(10);
   V_IDUTUFORIG        VARCHAR(1);
   V_IDUTUFDEST        VARCHAR(1);
   V_SGESTORIG         VARCHAR(5);
   V_SGESTDEST         VARCHAR(5);
   V_PAISORIG          VARCHAR(5);
   V_PAISDEST          VARCHAR(5);
BEGIN
   /*BUSCA A EMPRESA DA FILIAL*/
   BEGIN
      SELECT CDEMPRESA, CDINSCESTA
        INTO V_CDEMPRESA, V_CDINSCESTA
        FROM FILIAL
       WHERE CDFILIAL = P_CDFILIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDEMPRESA  := NULL;
         V_CDINSCESTA := NULL;
   END;
   FOR C_ITVEN IN (SELECT IV.CDFILIAL, V.DTENTRVENDA, IV.CDCAIXA, P.CDARVPROD, P.CDPRODUTO, SUM(((VRUNITVEND+VRUNITVENDCL)*QTPRODVEND)+VRACRITVEND-VRDESITVEND) AS VRPRODUTO
                     FROM VENDA V, ITEMVENDA IV, PRODUTO P
                    WHERE V.CDFILIAL   = IV.CDFILIAL
                      AND V.CDCAIXA    = IV.CDCAIXA
                      AND V.NRSEQVENDA = IV.NRSEQVENDA
                      AND IV.CDPRODUTO = P.CDPRODUTO
                      AND V.CDFILIAL   = P_CDFILIAL
                      AND IDSITUVENDA  = 'O'
                      AND DTENTRVENDA BETWEEN P_DTINICIAL AND P_DTFINAL
                      AND (INSTR(P_CDCAIXA, V.CDCAIXA) > 0 OR P_TCDCAIXA = 'T')
                   GROUP BY IV.CDFILIAL, IV.CDCAIXA, P.CDPRODUTO, P.CDARVPROD, V.DTENTRVENDA) LOOP
      FOR IMP IN(SELECT CDIMPOSTO
                   FROM IMPOSTO
                  WHERE IDORGARRECAD = 'F') LOOP
         V_GRUPOFISC := NULL;
         /*VERIFICA SE EXISTE GRUPO FISCAL DE IMPOSTO POR FILIAL*/
         BEGIN
             SELECT GR.CDGRUPOFISC
               INTO V_GRUPOFISC
               FROM GRUPOFISCIMPFIL GR, FILIAL F
              WHERE CDIMPOSTO  = IMP.CDIMPOSTO
                AND F.CDFILIAL = P_CDFILIAL
                AND F.CDFILIAL = GR.CDFILIAL;
          EXCEPTION
             WHEN NO_DATA_FOUND THEN
                V_GRUPOFISC := NULL;
          END;
          IF V_GRUPOFISC IS NULL THEN  /*VERIFICA SE EXISTE GRUPO FISCAL PARA IMPOSTO/IE SELECIONADA*/
             BEGIN
                SELECT GR.CDGRUPOFISC
                  INTO V_GRUPOFISC
                  FROM GRFISIMPIECLIE GR, FILIAL F
                 WHERE CDIMPOSTO    = IMP.CDIMPOSTO
                   AND F.CDINSCESTA = GR.CDINSCESTA
                   AND F.CDEMPRESA  = GR.CDEMPRESA
                   AND GR.CDCLIENTE = P_CDCLIENTE
                   AND F.CDFILIAL   = P_CDFILIAL;
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_GRUPOFISC := NULL;
             END;
          END IF;
          IF V_GRUPOFISC IS NULL THEN  /*VERIFICA SE H GRUPO FISCAL  PARA A FILIAL*/
             BEGIN
                SELECT CDGRUPOFISC
                  INTO V_GRUPOFISC
                  FROM FILIAL
                 WHERE CDFILIAL = P_CDFILIAL;
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_GRUPOFISC := NULL;
             END;
          END IF;
          IF V_GRUPOFISC IS NULL THEN  /*VERIFICA SE H GRUPO FISCAL PARA CLIENTE*/
             BEGIN
                SELECT CDGRUPOFISC
                  INTO V_GRUPOFISC
                  FROM CLIENTE
                 WHERE CDCLIENTE = P_CDCLIENTE;
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_GRUPOFISC := NULL;
             END;
          END IF;
          CONSULTA_INCIDENCIA('S', V_CDEMPRESA, C_ITVEN.CDARVPROD, V_CDINSCESTA, P_TIPOOPER, P_CDFILIAL, P_LANCTONF, V_GRUPOFISC, '', '', 'VND');
          FOR CS IN(SELECT CDIMPOTEMP, CDFISCTEMP
                      FROM INCITEMP
                     WHERE NRINCITEMP = P_CDFILIAL||P_LANCTONF
                       AND CDIMPOTEMP = IMP.CDIMPOSTO) LOOP
             CONSULTA_CST_NFE('S', V_CDEMPRESA, C_ITVEN.CDARVPROD, V_CDINSCESTA, P_TIPOOPER, V_GRUPOFISC, CS.CDIMPOTEMP, 'N','N', P_CDFILIAL, P_LANCTONF, V_CSTNFE, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
             /*VERIFICA SE UTILIZA ALIQUOTA POR ESTADO DE DESTINO E ORIGEM*/
             BEGIN
                SELECT IDUTUFORIG, IDUTUFDEST
                  INTO V_IDUTUFORIG, V_IDUTUFDEST
                  FROM IMPOSTO
                 WHERE CDIMPOSTO = CS.CDIMPOTEMP;
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_IDUTUFORIG := NULL;
                   V_IDUTUFDEST := NULL;
             END;
             V_SGESTORIG := NULL;
             V_PAISORIG  := NULL;
             /*UF/PAS DE ORIGEM*/
             IF V_IDUTUFORIG = 'S' THEN
                BEGIN
                   SELECT ED.SGESTADO, ED.CDPAIS
                     INTO V_SGESTORIG, V_PAISORIG
                     FROM FILIAL F, ENDEFILI ED
                    WHERE F.CDFILIAL = ED.CDFILIAL
                      AND F.CDFILIAL = P_CDFILIAL
                      AND NVL(F.IDENDCFOPFIL,'P') = ED.IDTPENDEFILI;      
                EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                      V_SGESTORIG := NULL;
                      V_PAISORIG  := NULL;
                END;
             END IF;
             V_SGESTDEST := NULL;
             V_PAISDEST  := NULL;
             /*UF/PAS DE DESTINO*/
             IF V_IDUTUFDEST = 'S' THEN
                BEGIN
                   SELECT ED.SGESTADO, ED.CDPAIS
                     INTO V_SGESTDEST, V_PAISDEST
                     FROM CLIENTE C, ENDECLIE ED
                    WHERE C.CDCLIENTE    = ED.CDCLIENTE
                      AND C.CDCLIENTE    = P_CDCLIENTE
                      AND C.IDENDCFOPCLI = ED.IDTPENDECLIE; 
                EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                      V_SGESTDEST := NULL;
                      V_PAISDEST  := NULL;
                END;
             END IF;
             CONSULTA_ALIQUOTA(CS.CDIMPOTEMP, 'S', V_CDEMPRESA, C_ITVEN.CDARVPROD, V_CDINSCESTA, V_PAISORIG, V_SGESTORIG, V_PAISDEST, V_SGESTDEST, '', '', C_ITVEN.DTENTRVENDA, P_CDFILIAL, P_LANCTONF, V_GRUPOFISC, P_TIPOOPER, 'VND');
             V_VRALIQIMP := NULL;
             SELECT MAX(VRALIQUTMP)
               INTO V_VRALIQIMP
               FROM ALIQTEMP
              WHERE NRALIQTEMP = P_CDFILIAL||P_LANCTONF;
             DELETE FROM ITEMVENOUTIMPOS
              WHERE CDFILIAL   = C_ITVEN.CDFILIAL
                AND CDCAIXA    = C_ITVEN.CDCAIXA
                AND DTREDUCAOZ = C_ITVEN.DTENTRVENDA
                AND CDIMPOSTO  = CS.CDIMPOTEMP
                AND CDPRODUTO  = C_ITVEN.CDPRODUTO;
             INSERT INTO ITEMVENOUTIMPOS
                (CDFILIAL, CDCAIXA, DTREDUCAOZ, CDIMPOSTO, CDPRODUTO, CDSITUTRIBNFE, VRALIQIT, VRPRODUTO, CDFISCALIT, CDTPCRPICOSTNFE, CDNATUBCPCSTNFE)
             VALUES 
                (C_ITVEN.CDFILIAL, C_ITVEN.CDCAIXA, C_ITVEN.DTENTRVENDA, CS.CDIMPOTEMP, C_ITVEN.CDPRODUTO, V_CSTNFE, NVL(V_VRALIQIMP,0), C_ITVEN.VRPRODUTO, CS.CDFISCTEMP, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE);
             DELETE FROM ALIQTEMP
              WHERE NRALIQTEMP = P_CDFILIAL||P_LANCTONF;
          END LOOP;
          DELETE FROM INCITEMP
           WHERE NRINCITEMP = P_CDFILIAL||P_LANCTONF;
      END LOOP;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_IMP_FEDERAIS_VND','5.25.000'); END;
/

